org.apache.tools.ant.taskdefs.optional.ejb

## Class IPlanetDeploymentTool

- java.lang.Object
- - org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool
  - - org.apache.tools.ant.taskdefs.optional.ejb.IPlanetDeploymentTool

- All Implemented Interfaces:
    EJBDeploymentTool

      public class IPlanetDeploymentTool
      extends GenericDeploymentTool

  This class is used to generate iPlanet Application Server (iAS) 6.0 stubs and skeletons and build an EJB Jar file. It is designed to be used with the Ant `ejbjar` task. If only stubs and skeletons need to be generated (in other words, if no JAR file needs to be created), refer to the `iplanet-ejbc` task and the `IPlanetEjbcTask` class.

  The following attributes may be specified by the user:

  - destdir -- The base directory into which the generated JAR files will be written. Each JAR file is written in directories which correspond to their location within the "descriptordir" namespace. This is a required attribute.
  - classpath -- The classpath used when generating EJB stubs and skeletons. This is an optional attribute (if omitted, the classpath specified in the "ejbjar" parent task will be used). If specified, the classpath elements will be prepended to the classpath specified in the parent "ejbjar" task. Note that nested "classpath" elements may also be used.
  - keepgenerated -- Indicates whether or not the Java source files which are generated by ejbc will be saved or automatically deleted. If "yes", the source files will be retained. This is an optional attribute (if omitted, it defaults to "no").
  - debug -- Indicates whether or not the ejbc utility should log additional debugging statements to the standard output. If "yes", the additional debugging statements will be generated (if omitted, it defaults to "no").
  - iashome -- May be used to specify the "home" directory for this iPlanet Application server installation. This is used to find the ejbc utility if it isn't included in the user's system path. This is an optional attribute (if specified, it should refer to the `[install-location]/iplanet/ias6/ias` directory). If omitted, the ejbc utility must be on the user's system path.
  - suffix -- String value appended to the JAR filename when creating each JAR. This attribute is not required (if omitted, it defaults to ".jar").

  For each EJB descriptor found in the "ejbjar" parent task, this deployment tool will locate the three classes that comprise the EJB. If these class files cannot be located in the specified `srcdir` directory, the task will fail. The task will also attempt to locate the EJB stubs and skeletons in this directory. If found, the timestamps on the stubs and skeletons will be checked to ensure they are up to date. Only if these files cannot be found or if they are out of date will ejbc be called.

  See Also:
    `IPlanetEjbc`

- - ### Field Summary

    - ### Fields inherited from class org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool

      `ANALYZER_CLASS_FULL, ANALYZER_CLASS_SUPER, ANALYZER_FULL, ANALYZER_NONE, ANALYZER_SUPER, DEFAULT_ANALYZER, DEFAULT_BUFFER_SIZE, EJB_DD, JAR_COMPRESS_LEVEL, MANIFEST, META_DIR`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IPlanetDeploymentTool()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addVendorFiles(java.util.Hashtable ejbFiles, java.lang.String ddPrefix)` Add the iAS-specific EJB descriptor to the list of files which will be written to the JAR file.
    `protected void` | `checkConfiguration(java.lang.String descriptorFileName, javax.xml.parsers.SAXParser saxParser)` Verifies that the user selections are valid.
    `protected java.lang.String` | `getPublicId()` The iAS ejbc utility doesn't require the Public ID of the descriptor's DTD for it to process correctly--this method always returns `null` .
    `protected java.util.Hashtable` | `parseEjbFiles(java.lang.String descriptorFileName, javax.xml.parsers.SAXParser saxParser)` This method returns a list of EJB files found when the specified EJB descriptor is parsed and processed.
    `void` | `processDescriptor(java.lang.String descriptorName, javax.xml.parsers.SAXParser saxParser)` Process a deployment descriptor, generating the necessary vendor specific deployment files.
    `void` | `setDebug(boolean debug)` Sets whether or not debugging output will be generated when ejbc is executed.
    `void` | `setGenericJarSuffix(java.lang.String inString)` Since iAS doesn't generate a "generic" JAR as part of its processing, this attribute is ignored and a warning message is displayed to the user.
    `void` | `setIashome(java.io.File iashome)` Setter method used to store the "home" directory of the user's iAS installation.
    `void` | `setKeepgenerated(boolean keepgenerated)` Setter method used to specify whether the Java source files generated by the ejbc utility should be saved or automatically deleted.
    `void` | `setSuffix(java.lang.String jarSuffix)` Setter method used to specify the filename suffix (for example, ".jar") for the JAR files to be created.

    - ### Methods inherited from class org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool

      `addFileToJar, addSupportClasses, checkAndAddDependants, configure, createClasspath, getClassLoaderForBuild, getCombinedClasspath, getConfig, getDescriptorHandler, getDestDir, getJarBaseName, getLocation, getManifestFile, getTask, getVendorDDPrefix, log, needToRebuild, registerKnownDTDs, setClasspath, setDestdir, setTask, usingBaseJarName, validateConfigured, writeJar`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IPlanetDeploymentTool

          public IPlanetDeploymentTool()

  - ### Method Detail

    - #### setIashome

          public void setIashome(java.io.File iashome)

      Setter method used to store the "home" directory of the user's iAS installation. The directory specified should typically be `[install-location]/iplanet/ias6/ias`.
      Parameters:
        `iashome` - The home directory for the user's iAS installation.

    - #### setKeepgenerated

          public void setKeepgenerated(boolean keepgenerated)

      Setter method used to specify whether the Java source files generated by the ejbc utility should be saved or automatically deleted.
      Parameters:
        `keepgenerated` - boolean which, if `true`, indicates that Java source files generated by ejbc for the stubs and skeletons should be kept.

    - #### setDebug

          public void setDebug(boolean debug)

      Sets whether or not debugging output will be generated when ejbc is executed.
      Parameters:
        `debug` - A boolean indicating if debugging output should be generated

    - #### setSuffix

          public void setSuffix(java.lang.String jarSuffix)

      Setter method used to specify the filename suffix (for example, ".jar") for the JAR files to be created.
      Parameters:
        `jarSuffix` - The string to use as the JAR filename suffix.

    - #### setGenericJarSuffix

          public void setGenericJarSuffix(java.lang.String inString)

      Since iAS doesn't generate a "generic" JAR as part of its processing, this attribute is ignored and a warning message is displayed to the user.
      Overrides:
        `setGenericJarSuffix` in class `GenericDeploymentTool`
      Parameters:
        `inString` - the string to use as the suffix. This parameter is ignored.

    - #### processDescriptor

          public void processDescriptor(java.lang.String descriptorName,
                               javax.xml.parsers.SAXParser saxParser)

      Process a deployment descriptor, generating the necessary vendor specific deployment files...
      Specified by:
        `processDescriptor` in interface `EJBDeploymentTool`
      Overrides:
        `processDescriptor` in class `GenericDeploymentTool`
      Parameters:
        `descriptorName` - the name of the deployment descriptor
        `saxParser` - a SAX parser which can be used to parse the deployment descriptor.

    - #### checkConfiguration

          protected void checkConfiguration(java.lang.String descriptorFileName,
                                javax.xml.parsers.SAXParser saxParser)
                                     throws BuildException

      Verifies that the user selections are valid.
      Overrides:
        `checkConfiguration` in class `GenericDeploymentTool`
      Parameters:
        `descriptorFileName` - String representing the file name of an EJB descriptor to be processed
        `saxParser` - SAXParser which may be used to parse the XML descriptor
      Throws:
        `BuildException` - If the user selections are invalid.

    - #### parseEjbFiles

          protected java.util.Hashtable parseEjbFiles(java.lang.String descriptorFileName,
                                          javax.xml.parsers.SAXParser saxParser)
                                               throws java.io.IOException,
                                                      org.xml.sax.SAXException

      This method returns a list of EJB files found when the specified EJB descriptor is parsed and processed.
      Overrides:
        `parseEjbFiles` in class `GenericDeploymentTool`
      Parameters:
        `descriptorFileName` - String representing the file name of an EJB descriptor to be processed
        `saxParser` - SAXParser which may be used to parse the XML descriptor
      Returns:
        Hashtable of EJB class (and other) files to be added to the completed JAR file
      Throws:
        `java.io.IOException` - An IOException from the parser, possibly from the byte stream or character stream
        `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception

    - #### addVendorFiles

          protected void addVendorFiles(java.util.Hashtable ejbFiles,
                            java.lang.String ddPrefix)

      Add the iAS-specific EJB descriptor to the list of files which will be written to the JAR file.
      Overrides:
        `addVendorFiles` in class `GenericDeploymentTool`
      Parameters:
        `ejbFiles` - Hashtable of EJB class (and other) files to be added to the completed JAR file.
        `ddPrefix` - not used

    - #### getPublicId

          protected java.lang.String getPublicId()

      The iAS ejbc utility doesn't require the Public ID of the descriptor's DTD for it to process correctly--this method always returns `null` .
      Overrides:
        `getPublicId` in class `GenericDeploymentTool`
      Returns:
        `null`.